<?php 
$version="0.45";
function license(){
echo '
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <a href="http://www.gnu.org/licenses/">http://www.gnu.org/licenses/</a>
';
}
## DEBUGG ##
//ini_set('display_errors', 1);
//ini_set('display_startup_errors', 1);
//error_reporting(E_ALL);
## DEBUGG ##

## USER SETTINGS ###
$allowedDepth=0; 		// Maximum folder depth, 0 = only same folder as the php file. 
				// 1 = The folders that are in the same folder as this script can be accessed. 
$alljpg=true; 			// Control if only pictures are shown in jpg mode by default. true/false
$thumbPath = "./.thumbs/";	// path where all thumbnails are stored
$warnings=true;			// if true shows warnings, false hides all warnings
$htwarnings=true;		// hide just htaccess missmatch warnings
$pdfQuartzwarnings=true;	// display warnings when processing pdf that are created with Quartz
$privateFiles = array("index.php",".php","~",".html","1771487.jpg");  // File types, files, or anything which ends matches something on this list will not be displayed. Must be in lowercase
							// files that start with . will be hidden by default
$thumbWidthJpg = 1920;		// amount of horizontal pixels for the big picture shown in jpg mode view
$thumbWidthList = 20;		// amount of horizontal picels for thumbnails in list view
$thumbWidthGrid = 350;		// amount of horizontal picels for thumbnails in grid view (these thumbnails are also used in thumnaisl shown on bottom of the screen in JPG mode)
$GifSizeLimit= 500000;		// Thumbnails will not be used for gifs smaller than this. This allows animated gifs to work (if they are smaller than this setting) Size in bytes
$privateFolders = array("testi9001","testi1337");	// Folders that you don't want to list.
## USER SETTINGS END ###

/* DEBUG / Installation notes
Warning: Unknown: failed to open stream: Permission denied in Unknown on line 0 == selinux problem
500 Internal Server Error == Usually permission issue (suphp?). try chmod 755 <folder> and chmod 644 <file> .	

## IMAGICK on redhat/centos
yum install gcc php-devel php-pear
yum install ImageMagick ImageMagick-devel
pecl channel-update pecl.php.net
pecl install imagick
echo "extension=imagick.so" > /etc/php.d/imagick.ini
service httpd reload

## ICONS 
Download the icons from
http://www.rcnp.osaka-u.ac.jp/~www-cn/tools/FileViewer/?view=list
Place the icons in <PATH TO WEB SERVERS ICONS>/fv/
OR
create folder called ".icons" in the same folder as the php script and place all icons inside the folder.

*/
date_default_timezone_set('Asia/Tokyo');	# to prevent php warning each time script is run
global $thumbPath,$supported,$warnings,$htwarnings,$thumbWidth,$pdfQuartzwarnings,$pics,$alljpg,$allowedDepth,$privateFolders,$privateFiles,$GifSizeLimit,$thumbWidthJpg,$thumbWidthList,$thumbWidthGrid;
$supported = array(							// Files that have either icon or thumbnail
".jpg",".jpeg",".png",".gif", 						// Images
".doc",".xlsx",".xls",".pdf",".pptx",".ppt",".docx", 			// Documents
".zip",".rar",".tar",".gz",".7z",".iso",".bin",".img",			// Compressed/images
".h",".cmd",".bat",".py",".sh",".txt",".log",".c",".conf",		// text/source files/scripts
".avi",".mp4",".mkv",".mpeg",".flv",".mov",".mpq",			// Video Files
".mp3",".wav",".flac",".m4a",".wma",".mid",".m3u",".pls",		// Audio
".ttf",".fon",".otf",							// font
".deb",".rpm",".dmg",".msi",".exe",".apk"				// installers / executables
); 
$supportedthumbs= array(						//Files that will have thumbnails generated			
".pdf",									// PDF First page is generated
".jpg",".jpeg",".png",".gif",						// Thumbnails will be generated. Size is defined in # USER SETTINGS #
".txt",".log",".c",".bat",".py",".sh",".conf",".h",".cmd",".bat"	// Thumbnails will be generated. Displaying few lines of the text.
);	
$testdir="";		
$dir = "./";	# set dir to something
$defaultview = "grid";   # sets the default view, (grid or list)
$view=$defaultview;
$GLOBALS['alljpg']=$alljpg;
if(isset($_GET["view"]))	// else if view type is set
{
	$view=htmlentities($_GET["view"],ENT_COMPAT,"UTF-8");
}
if(!isset($_GET["dl"])){
echo "<!DOCTYPE html>
<HTML>
<head>
<meta charset=\"UTF-8\">
<!--";
license();
echo "-->
";
echo '<title>File viewer</title><style type="text/css">';
if($view=="jpg" || isset($_GET["about"])){
 	echo '
html,body {';
	if(isset($_GET["about"])){ // Set size and background if showing help/about page
 		echo "height: 100%;
 		width:100%;
 		background: Lavender;";
	}else{
 		echo 'height: 100%;
 		overflow-y:hidden';
	}
}else{  // grid and list view
	echo '
	body {
	overflow-y:auto;
	overflow-x:hidden;';
}
echo '}';
echo '
.scroll{ }
a{
	text-decoration: none;
}
pre{
	display:inline-block;
	background:white;
}
a.footerlink{
	color:"#0000FF"
}
.helper {
	white-space: nowrap;
	overflow: hidden;
   	 display: inline-block;
   	 height: 100%;
   	 vertical-align: middle;
}
#settingbar {
	 flex-wrap:nowrap;
	display: flex;
	white-space: nowrap;
	overflow: hidden;
    background-color:DarkGray;
    color:white;
    padding:2px;
}
#title {
	flex:1;
	width:auto;
	white-space: nowrap;
	overflow: hidden;
	text-align:left;
	float:left;
	margin:0;
	padding:0;
	color:black;
}
#title2 {	
	width:auto;
	white-space: nowrap;
	overflow: hidden;
	text-align: center;
	float:left;
	margin:0;
	padding:0;
	color:black;
	text-overflow: ellipsis;
}
#view {
    color:white;
}

.fileinfo{
	display: flex;
	height:20px;
	white-space: nowrap;
	overflow: hidden;
	background-color:Lavender;
}
.fileinfo2{
	display: flex;
	height:20px;
	white-space: nowrap;
	overflow: hidden;
	background-color:GhostWhite;
}
#fileinfo3{
	display: flex;
	height:20px;
	overflow: hidden;
	white-space: nowrap;
	background-color:gray;
	text-overflow: ellipsis;
}
.fileicon{
	height:20px;
	width:20px;
	margin-left: 0px;
	margin-right: 6px;
	float:left;
}
.fileicon1{
	height:20px;
	width:20px;
	margin-left: 0px;
	margin-right: 6px;
	float:left;
}

.name{
	overflow: hidden;
	text-overflow: ellipsis;
}
.nameLink {
	flex:1;
	min-width: 0;

}
.type{
	overflow: hidden;
	text-overflow: ellipsis;
	white-space: nowrap;
	text-align:right;
	padding-right:2px;
	width:45px;
	float:right;
}
.modified{
	white-space: nowrap;
	overflow: hidden;
	text-overflow: ellipsis;
	padding-left:2px;
	text-align: right;
	padding-right: 1px;
	width:150px;
	float:right;
}
.spacer{
	white-space: nowrap;
	float:right;
	width:1px;
	background-color:black;
}
.spacer2{
	white-space: nowrap;
	float:left;
	width:1px;
	background-color:black;
	
}
.filesize{
	white-space: nowrap;
	overflow: hidden;
	text-align:right;
	padding-right:2px;
	width:90px;
	float:right;
}
.allcontainer{
	white-space: nowrap;
	overflow: hidden;
	background-color:Lavender;
	overflow:hidden;
}
.container {
    	height:168px;
    	margin:2px;
    	float:left;
    	overflow: hidden;
    	text-overflow: ellipsis;
    	width: 202px;
    	border: 2px solid black;
}
.container2 {
	white-space: nowrap;
	overflow: hidden;
	float:left;
	width:200px;
}
.pictures {
	float:left;
	height: 150px;      
	width: 200px;
	white-space: nowrap;
	text-align: center; 
	margin: 0;
}
.picture{
	vertical-align: middle;
	max-height: 150px;
	max-width: 200px;
}
.picturetext {
   	float:left;
	width:90%;
	height:20px;
	overflow: hidden;
	text-decoration: none;
	text-overflow: ellipsis;
}
.download {
 	float:left;
	width:20px;
	height:20px;
}
.downloadlist {
	margin-left:2px;
 	float:left;
	width:20px;
	height:20px;
}
.cube {
	width:16px;
}
.icon {
	width:18px;
	height:18px;
	padding:2px;
}
.baricon{
	float:left;
	height:16px;
	overflow:hidden;
	padding:2px;	
}
.baricon2{
	white-space: nowrap;
	height:16px;
	float:right;
	overflow:hidden;
	padding:2px;	
}
.thumb{
	width:50px;
	height:50px;
}
.downloadicon{
	width:16px;
	height:16px;
}
.full {
	display:block;
	max-width:100%;
	max-height:100%;
	position: relative;
        top: 50%;
        left: 50%;
        transform: translateX(-50%) translateY(-50%);
}
.img-with-text {
	max-width:100%;
	max-height:100%;
	position: relative;
        top: 50%;
        left: 50%;
        transform: translateX(-50%) translateY(-50%);
	width:100%;
	height:20px;
}
.img-text {
	display: inline-block;
	position: relative;
        left: 50%;
        transform: translateX(-50%) translateY(-50%);
}
.no-picture {
	display: inline-block;
	position: relative;
        left: 50%;
        top:50%;
        transform: translateX(-50%) translateY(-50%);
}
.selectpictures {
	height:100%;
	white-space: nowrap;
	text-align: center; 
	margin: 0;

}
.selectpictures2{
	position: relative;
        top: 50%;
        left: 50%;
        transform: translateX(-50%) translateY(-50%);
}
.fullcontainer {
    width: 100%;
    height: 83%;
    background: Lavender;
    margin: 0 auto;
    overflow-x:hidden;
    overflow-y:auto;
}
.fullcontainer img.wide {
    max-width: 100%;
    max-height: 100%;
    height: auto;
}
.fullcontainer img.tall {
    max-height: 100%;
    max-width: 100%;
    width: auto;
}​
.jpggridcontainer{
    width: 100%;
    height: 100%;
    overflow-y:hidden;
    overflow-x:hidden;
    background: Lavender;
    margin: 0 auto;
}
.selectcontainer2 {
	white-space: nowrap;
	float:left;
	height:50%;
    	width: 100%;
}
.selectcontainer {
    	height:90%;
    	width: 80px;
    	margin:1px;
    	display: inline-block;
    	overflow: hidden;
    	text-overflow: ellipsis;
    	border: 2px solid black;
}
.currentselectcontainer {
    	height:90%;
    	width: 80px;
    	margin:1px;
    	display: inline-block;
    	overflow: hidden;
    	text-overflow: ellipsis;
    	border: 2px solid white;
}
.selectpicture{
	vertical-align: middle;
	max-height: 100%;
	max-width: 100%;
}
.selectpicturetext {
   	float:left;
   	font-size:12px;
	width:85%;
	height:10%;
	overflow: hidden;
	text-decoration: none;
	text-overflow: ellipsis;
	
}
.selectdownload {
 	float:left;
	width:10%;
	height:9%;
	margin-right:4px;
}
.top{
   float:left;
   height: 100%;
   width: 100%;

}
.bottom{
 white-space: nowrap;
 position:absolute;
 height:10%;
 background:DarkGray;
 left:0;
 right:0;
 margin:8px;
 bottom: 0px;
 overflow-y: hidden;
 overflow-x: hidden;
}
.allign{
	text-align: center;
   	height:100%;
	margin: 0 auto;
}
.buttonalign{
    position: relative;
    top: 50%;
    left: 50%;
    transform: translateX(-50%) translateY(-50%);
}
.first {
    	height:90%;
    	width: 40px;
    	margin:1px;
    	display: inline-block;
    	overflow: hidden;
    	text-overflow: ellipsis;
    	border: 2px solid black;
}
.firstg {
    	height:90%;
    	width: 40px;
    	margin:1px;
    	display: inline-block;
    	overflow: hidden;
    	text-overflow: ellipsis;
    	border: 2px solid gray;
}
.last {
    	height:90%;
    	width: 40px;
    	margin:1px;
    	display: inline-block;
    	overflow: hidden;
    	text-overflow: ellipsis;
    	border: 2px solid black;
}
.lastg {
    	height:90%;
    	width: 40px;
    	margin:1px;
    	display: inline-block;
    	overflow: hidden;
    	text-overflow: ellipsis;
    	border: 2px solid gray;
}
.previous {
	line-height: 100%;       /* the same as your div height */
    	height:90%;
    	width: 50px;
    	margin:1px;
    	display: inline-block;
    	overflow: hidden;
    	text-overflow: ellipsis;
    	border: 2px solid black;
}
.previousg {
	line-height: 100%;       /* the same as your div height */
    	height:90%;
    	width: 50px;
    	margin:1px;
    	display: inline-block;
    	overflow: hidden;
    	text-overflow: ellipsis;
    	border: 2px solid gray;
}
.previous5 {
	line-height: 100%;       /* the same as your div height */
    	height:90%;
    	width: 40px;
    	margin:1px;
    	display: inline-block;
    	overflow: hidden;
    	text-overflow: ellipsis;
    	border: 2px solid black;
}
.previousg5 {
	line-height: 100%;       /* the same as your div height */
    	height:90%;
    	width: 40px;
    	margin:1px;
    	display: inline-block;
    	overflow: hidden;
    	text-overflow: ellipsis;
    	border: 2px solid gray;
}
.next {
    	height:90%;
    	width: 50px;
    	margin:1px;
    	display: inline-block;
    	overflow: hidden;
    	text-overflow: ellipsis;
    	border: 2px solid black;
}
.nextg {
    	height:90%;
    	width: 50px;
    	margin:1px;
    	display: inline-block;
    	overflow: hidden;
    	text-overflow: ellipsis;
    	border: 2px solid gray;
}
.next5 {
    	height:90%;
    	width: 40px;
    	margin:1px;
    	display: inline-block;
    	overflow: hidden;
    	text-overflow: ellipsis;
    	border: 2px solid black;
}
.nextg5 {
    	height:90%;
    	width: 40px;
    	margin:1px;
    	display: inline-block;
    	overflow: hidden;
    	text-overflow: ellipsis;
    	border: 2px solid gray;
}
.allcheckbox{
	height:10px;
	margin:0;
	margin-right:20px;
	padding:0;
	color:black;
}
</style>
</head>
<body>';
if(file_exists("./.icons/")){   //if found, use icons in scripts folder 
	$iconpath="./.icons";
}else{
	$iconpath="/icons/fv";
}
if(isset($_GET['alljpg'])){
	if(filter_var($_GET['alljpg'], FILTER_VALIDATE_BOOLEAN)){
		$GLOBALS['alljpg']=true;
	}else{
		$GLOBALS['alljpg']=false;	
	}
}
}
if(isset($_GET["dl"])){
	$dir=checkpath($allowedDepth,$privateFiles,$privateFolders);   // checks that the script is not trying to access anything outisde script directory
	$files['files']=scandir($dir);			// save file list to array
	$files = removeExtra($files,$dir,$allowedDepth,	$privateFiles,$privateFolders);	 // Remove private files + and directories if necessary
	if($id=array_search($_GET["dl"],$files["files"])){
		$filename=$files["files"][$id];
		$filepath=$dir . $filename;
		switch (strtolower(pathinfo($filepath, PATHINFO_EXTENSION))): 
			case "jpg":
			case "jpeg": $filetype="image/jpeg";break;
			case "pdf":$filetype="application/pdf";break;
			case "png":$filetype="image/png";break;
			case "gif":$filetype="image/gif";break;
			case "bmp":$filetype="image/bmp";break;
			case "ico":$filetype="image/ico";break;
			case "log":
			case "conf":
			case "txt": $filetype="text/plain";break;
			default:$filetype="application/octet-stream";break;
		endswitch;
		header('Content-Type:  ' . $filetype);
		header('Content-Length: '.filesize($filepath));
		header("Content-Disposition: attachment; filename=\"$filename\"");
		readfile($filepath); 
		exit;
	}else{
		linkerror(); 	// Print error and exit
	}
}
elseif(isset($_GET["about"])){	// If about is pressed
	//echo "<div class=about>";
	echo "<h2>File viewer version ",$version,"</h2>";
	echo "<h3>Key bindings in jpg mode</h3>";
	echo "<ul><li>Left arrow key - Previus picture</li>";
	echo "<li>Right arrow key - Next picture</li>";
	echo "<li>Up arrow key - Last picture</li>";
	echo "<li>Down arrow key - First picture</li>";
	echo "</ul>";
	echo "<h3>License</h3>";
	echo "<pre>";
	license();
	echo "</pre><br>";
	echo "<h3>Icons</h3>";
	echo "All the static icons used are used under Creative Commons Attribution 2.5 License from";
	echo "<br><a href=http://www.famfamfam.com/lab/icons/silk/> famfamfam.com/lab/icons/silk/ </a><br>";
	echo "except the download.png which is combination/modification of two different icons also included in the same collection.";
	echo "<br>";
	echo "<hr>";
	echo '<a href="?view=';
	echo $view;
	echo '" class="footerlink" > Return to File viewer</a>';
	echo '<form action="" method="get">';
	echo '<input type="submit" value="Delete thumbs" name="delete">';
	echo '</form>';
	//echo "</div>";
}
else{
	if(isset($_GET["reset"])) // If home/reset is pressed
	{
		$dir = "./";
	}
	elseif(isset($_GET["dir"]))	// Else if tries to change shown folder
	{
		$dir=checkpath($allowedDepth,$privateFiles,$privateFolders);
	}
	else # default to root folder
	{
		$dir="./";
	}
$files['files']=scandir($dir);			// save file list to array

if(isset($_GET["delete"])){		// if delete is set
functionbar($dir,$iconpath,null,$view,$defaultview);
	if(is_dir($thumbPath)){
		echo "Removing thumbs.....";
		if(removethumbs("./.thumbs/")){ // try to delete  the thumbs
			echo "<br>Removed thumbs. (" . date(" H:i:s").")";
		}else{
			echo "<br>Removing thumbs failed. (" . date("H:i:s").")";
		}
	}else{
		echo "Could not find .thumbs folder. (" . date("H:i:s").")" ;	
	}		
}
else // Delete not set continuing
{
	$files = removeExtra($files,$dir,$allowedDepth,	$privateFiles,$privateFolders);	 // Remove private files + and directories if necessary
	loopfiles($files,$dir, "thumbs",$iconpath,$view);		// Generate the thumbnails
	if($view=="jpg"){
		echo '<div class="top">';
		functionbar($dir,$iconpath,$files,$view,$defaultview);	
	}else{
		functionbar($dir,$iconpath,null,$view,$defaultview);	
	}
				// Create the Top bar
	if($view=="grid"){					// Generate grid view if it's set
			loopfiles($files,$dir,"grid",$iconpath,$view);
	}
	elseif($view=="list"){					// else generate the list view
	echo '<div class="scroll">';
			infobar($iconpath);
		loopfiles($files,$dir,"list",$iconpath,$view);
			infobar($iconpath);
	echo "</div>";
	}elseif($view=="jpg"){
		loopfiles($files,$dir,"jpg",$iconpath,$view);
	}else{
		echo "something went wrong";			// if nothing is set print error, shoudln't happen
	}
}
if($view=="jpg"){
		
}else{
	functionbar($dir,$iconpath,null,$view,$defaultview);
}

}
function linkerror(){
	echo "invalid link";
	exit;
}
function checkpath($allowedDepth,$privateFiles,$privateFolders){
	$tempdir = htmlentities(rtrim($_GET["dir"], "/") . "/",ENT_COMPAT,"UTF-8"); // remove trailing / and remove unwanted characters
	$tempdir = htmlentities($tempdir, ENT_QUOTES);
	if (strpos(realpath($tempdir),dirname(__FILE__)) !== FALSE){ 			// Check if path is inside script folder
		if(strpos($tempdir,"./")===FALSE){					// If path doesn't start with ./ add it
			$tempdir= "./" . $tempdir;
		}
		if(substr_count($tempdir,'/') > $allowedDepth+1 || $tempdir== "."){ 	// If tries to access folder that is deeper than allowedDepth
			$tempdir = "./";
		}else{
			$count = substr_count($tempdir,'/');
			$testdir=$tempdir;
			for($i = 0; $i < $count; $i++ ){	
				$tempar=checkHtaccess($testdir);		
				if(!$tempar['enable'] || !privatecheck($testdir,$privateFiles,$privateFolders)){	
					$tempdir = "./";
					break;
				}
				$testdir=dirname($testdir);
			}
		}
		$dir=$tempdir;
	}
	else // Not inside script folder
	{
		linkerror(); // print error and exit
	}
	return $dir;
}
// This function is from  Jeffrey Sambells, http://jeffreysambells.com/2012/10/25/human-readable-filesize-php
function human_filesize($bytes, $decimals = 1) {   
    $size = array('B','kiB','MiB','GiB','TiB','PiB','EiB','ZiB','YiB');
    $factor = floor((strlen($bytes) - 1) / 3);
    return sprintf("%.{$decimals}f", $bytes / pow(1024, $factor)) ." ". @$size[$factor];
}

function removethumbs($thumbdir){
	$test=true;
	if (! is_dir($thumbdir)) {			// Fail if not folder
        	$test=false;
    	}else
	{
		if (substr($thumbdir, strlen($thumbdir) - 1, 1) != '/') {	// Check if last char is / and if not add it 
       			$thumbdir .= '/';
   		}
   	//	array_map('unlink', glob($thumbdir . '.*', GLOB_BRACE));
   		$files = glob($thumbdir . '{,.}[!.,!..]*', GLOB_BRACE);			// Make a list of all files and folders and sub folders and files in them
   		foreach ($files as $file) {					// loop through the files
   		if($file!=".." || $file!=".")
       	 		if (is_dir($file)) {					// if it's folder call itself again
          			if(removethumbs($file)==false){
					$test=false;
					if($GLOBALS['warnings']){echo "error removing dir error code 5<br>";}
					break;
				}
      			}else{
      				//echo "removing " . $file . "<br>";
	     		   	unlink($file); 					// else remove the thumbnail
        		}
    		}
    		//echo "rmdir " . $thumbdir;
		if(!rmdir($thumbdir)){ // if removing the folder fails
			$test=false;	// fail the test
			if($thumbdir=="./.thumbs/"){	// if the folder is the ./.thumbs display error message but don't fail 
    				if($GLOBALS['warnings']){echo "<br>Can't remove ./.thumbs/ folder automatically. Please remove it manually.<br>";}
    				$test=true;
			}
		}
	}
   return $test;	
}

function clean($url) {
    $parts = parse_url($url);
    return $parts['scheme'] . '://' . $parts['host'] . $parts['path'];
}

function functionbar($dir,$iconpath,$files,$view,$defaultview){ // Generate the functionbar
$piccount=0;
if($files!=null){
	if($GLOBALS['alljpg']){
		if(isset($files['folders'])){
			foreach($files['folders'] as $folder){
				$pics[]=$folder;
				$piccount++;
			}
		}
	}
	foreach($files['files'] as $file){
		$ext=strtolower(pathinfo($file, PATHINFO_EXTENSION));
		if(($ext=="jpg" || $ext =="png" || $ext =="gif" || $ext== "jpeg") || $GLOBALS['alljpg']){
			$pics[]=$file;
			$piccount++;
		}
	}
	if(isset($_GET['pic'])){
		$offset=filter_input(INPUT_GET, 'pic', FILTER_VALIDATE_INT);
		if($piccount<=$offset || $offset < 0){
			$offset=0;
		}
	}else{
		$offset=0;
	}
	if(isset($pics)){
		$GLOBALS['pics']=$pics;
	}

}
	echo '<div id="settingbar">';
	echo '<div id="title2">File viewer&nbsp;</div>';
	echo '<a href="?view=',$defaultview,'&amp;reset=1"><img alt="Home" src="' . $iconpath . '/house.png" class="baricon" /></a>';	
	
	if($view=="jpg"){
		echo '<a href="?view=',$view,'&amp;alljpg='.$GLOBALS['alljpg'].'&amp;dir=',dirname($dir),'"><img alt="Parent folder" src="' . $iconpath . '/resultset_previous.png" class="baricon" /></a>';
	}else{
		echo '<a href="?view=',$view,'&amp;dir=',dirname($dir),'"><img alt="Parent folder" src="' . $iconpath . '/resultset_previous.png" class="baricon" /></a>';
	}
		

	echo '<div id="title">';
	$depth= substr_count($dir , '/')-2; // Calculate the depth
	$path[] = $dir;			    // Start making array with paths
	for ( $x=0;$x<$depth;$x++){	    // loop until all paths are in the array
		$path[] = dirname($path[$x]);
	}
	end($path);				// move pointer to end of array
	if($path[key($path)]!=="./"){		// read from the pointer and if the last value in array is not ./ add it
		$path[]="./";
	}
	$path = array_reverse($path);		// reverse the array
	$lastpath=end($path);
	foreach ($path as $link){		// loop through the paths
		if($lastpath==$link && $link!="./"){	// if the path is last and it's not ./
			echo "", basename($link)," /";
		}
		elseif($lastpath==$link && $link=="./"){		// if path is ./ and last get the current folder name 
			echo "", basename(getcwd())," /";
		}elseif($link=="./"){					// get current folder path for root
			if($GLOBALS['alljpg']){
				
				echo '<a href="?view='.$view.'&amp;alljpg=1&amp;dir=',$link,'">',"",basename(getcwd()),'</a>  / ';
			}else{
				echo '<a href="?view='.$view.'&amp;dir=',$link,'">',"",basename(getcwd()),'</a>  / ';
			}
		}
		else
		{							// everything else as a link
			if($GLOBALS['alljpg']){

				echo '<a href="?view='.$view.'&amp;alljpg=1&amp;dir=',$link,'">',basename($link),'</a>  / ';
			}else{
				echo '<a href="?view='.$view.'&amp;dir=',$link,'">',basename($link),'</a>  / ';
			}
		}
	}
	if($files!=null){
		if(isset($pics)){
			if(is_dir($link.$pics[$offset])){
				echo '<a href="?pic='. $offset .'&amp;view=jpg&amp;alljpg=true&amp;dir='.$link.$pics[$offset] .'">';
			}else{
				echo '<a href="?dir='.$link.'&dl='.$pics[$offset] .'">';
			}

			echo $pics[$offset];
			echo '</a> ';
			$ext=strtolower(pathinfo($link.$pics[$offset], PATHINFO_EXTENSION));
			if($ext=="jpg" || $ext =="png" || $ext =="gif" || $ext== "jpeg"){
				$size = getimagesize($link.$pics[$offset]);
				echo "(".$size[0]."x".$size[1].")";
			}
			if(!is_dir($link.$pics[$offset])){
				//echo '<a href="'.$link.$pics[$offset].'" download><img class="downloadicon" src="' . $iconpath . '/download.png" alt="dl" />';
				echo '<a href="?dir='.$link.'&dl='.$pics[$offset]. '"><img class="downloadicon" src="' . $iconpath . '/download.png" alt="dl" />';
				echo '</a>';
			}

		}	
		echo '</div>';
		echo '<div class="allcheckbox">';
		if($GLOBALS['alljpg']){
			echo '<form action="">';
			echo '<input type="radio" checked>All Files';
			echo '<a style="text-decorations:none; color:inherit;" href="?pic='.$offset.'&amp;view=jpg&amp;alljpg=false&amp;dir='.$dir.'">';
			echo '<input type="radio">Only Pictures';
			echo '</a>';
		}else{
			echo '<form action="">';
			echo '<a style="text-decorations:none; color:inherit;" href="?pic='.$offset.'&amp;view=jpg&amp;alljpg=true&amp;dir='.$dir.'">';
			echo '<input type="radio">All Files';
			echo '</a>';
			echo '<input type="radio" checked>Only Pictures';
		}
		echo '</form>';
		echo '</div>';
	}else{
		echo '</div>';
	}
	echo '<div id="view">';	
	echo '<a href="?view=jpg&amp;alljpg='.$GLOBALS['alljpg'].'&amp;dir='.$dir.'"><img alt="jpg" src="' . $iconpath . '/pictures.png" class="baricon2" /></a>';
	echo '<a href="?view=grid&amp;dir='.$dir.'"><img alt="grid" src="' . $iconpath . '/application_view_icons.png" class="baricon2" /></a>';
	echo '<a href="?view=list&amp;dir='.$dir.'"><img alt="list/" src="' . $iconpath . '/application_view_list.png" class="baricon2" /></a>';
	echo '<a href="?about=1"><img alt="settings/" src="' . $iconpath . '/help.png" class="baricon2" /></a>';
	echo '</div>';
	echo '</div>';
}
function checkHtaccess($path){
	$result['enable']=true;
	$strlen = strlen($path);
    $testlen = strlen("/");
    if (substr_compare($path, "/", $strlen - $testlen, $testlen) !== 0){ 
		$path=$path . "/";
	}
	$htpath=$path . ".htaccess";
	$thumbdir=str_replace("/./","/",$GLOBALS["thumbPath"] . $path);
	$thumbhtaccess=$thumbdir . ".htaccess";
	#echo "path=".$path . "\r\n";
	#echo "thumbhtaccess=".$thumbhtaccess . "\r\n";
	#echo "thumbdir=".$thumbdir . "\r\n";
	#echo "htpath=".$htpath . "\r\n";
	if(file_exists($htpath)){
		if(!file_exists("./.htaccess")){
			if(!file_exists($thumbdir)){
				mkdir($thumbdir, 0755, true);
				chmod($thumbdir, 0755);
			}
			copy($htpath,$thumbhtaccess);
			chmod($thumbhtaccess, 0644);
			$result['enable'] = false;
		}
		elseif(filesize("./.htaccess") == filesize($htpath) &&  
		       md5_file("./.htaccess") == md5_file($htpath)  )
		{
			$result['enable']=true;
		}
		else
		{	
			if(!file_exists($thumbdir)){
				mkdir($thumbdir, 0755, true);
				chmod($thumbdir, 0755);
			}
			copy($htpath,$thumbhtaccess);
			chmod($thumbhtaccess, 0644);
			$result['enable'] = false;
		}
	}else{
		if(file_exists($thumbhtaccess)){
			unlink($thumbhtaccess);
		}
	}
		return $result;
}
function privatecheck($file,$privateFiles,$privateFolders){
	$file=trim($file,"./");
	$file=trim($file,"/");
	foreach ($privateFiles as $privateFile){	// Go through privatefiles and if matches remove it.
		$length = strlen($privateFile);
		if (strtolower(substr($file, -$length))===$privateFile){
			return false;
		}
	}
	foreach ($privateFolders as $privateFolder){	// Go through privatefiles and if matches remove it.
		$length = strlen($privateFolder);
		if(is_dir($file) && substr($file, -$length)===$privateFolder){
			return false;
		}
	}
	return true;
}
function removeExtra($files,$dir,$allowedDepth,$privateFiles,$privateFolders){
	$filestmp=array();			// Initialize array 
	$i = 0;
	foreach ($files['files'] as $file){// Loop the files
	
		if(substr( $file, 0, 1 )==="." ){	// if starts with . remove from list (current dir and previous dir)
			unset($files['files'][$i]);
			$i++;
			continue;		
		}

		if(!privatecheck($file,$privateFiles,$privateFolders)){
			unset($files['files'][$i]);
			$i++;
			continue;
		}
		if(is_dir($dir . $file))	// if file is dir and within allowedDepth limit add it to $folders array and delte from file array
		{
			if(substr_count($dir . $file,'/') < $allowedDepth+1){
				$result=checkHtaccess($dir . $file);
				if($result['enable']){
					$folders['folders'][$i] = $file;
				}
				elseif($GLOBALS['warnings'] && $GLOBALS['htwarnings'] && !isset($_GET['dl'])){
					echo "htaccess missmatch ",$dir . $file,"<br>";
				}
			}
			unset($files['files'][$i]);
		}
	$i++;
	}

	natcasesort($files['files']);		// sort files
	if(isset($folders)){		// if there is folders sort them and return folders and files both in one array where folders are first
		natcasesort($folders['folders']);
			return array_merge($folders,$files);	
	}else{				// if there is no folders only return files
		return $files;
	}
}

function infobar($iconpath){
echo '<div id="fileinfo3">';
	echo '<div class="spacer2">';	
		echo '&nbsp;';
	echo '</div>';

	echo '<div class="downloadlist">';
		echo	'<img class="downloadicon" src="' . $iconpath . '/download.png" alt="dl" />';
	echo '</div>';
	
		echo '<div class="spacer2">';	
		echo '&nbsp;';
	echo '</div>';
	
	
	echo '<div class="fileicon1">';
	echo '<img class="icon" src="' . $iconpath . '/pictures.png" alt="ico" />';	
	echo '</div>';



	echo '<div class="spacer2">';	
		echo '&nbsp;';
	echo '</div>';
	
	
	
	echo '<div class="nameLink">';	
		echo '<div class="name">';
			echo 'Filename';
		echo '</div>';		
	echo '</div>';
	

	
	echo '<div class="spacer">';	
		echo '&nbsp;';
	echo '</div>';
	echo '<div class="type">';	
		echo 'Type';
	echo '</div>';

	echo '<div class="spacer">';	
		echo '&nbsp;';
	echo '</div>';
	echo '<div class="modified">';	
		echo 'Modified';
	echo '</div>';
	echo '<div class="spacer">';	
			echo '&nbsp;';
	echo '</div>';

		echo '<div class="filesize">';	
		echo 'Size';
	echo '</div>';
	echo '<div class="spacer">';	
		echo '&nbsp;';
	echo '</div>';
	
echo '</div>';
}
function thumbnail($dir,$file,$type){
	if(in_array("." .strtolower(pathinfo($file, PATHINFO_EXTENSION)),$GLOBALS["supportedthumbs"])){ // check if filetype is in supportedthumbs array
				$thumbdir=str_replace("/./","/",$GLOBALS["thumbPath"] . $dir . "." . $type . "/"); 	// Remove extra /./ from the path	
				$filepath= $dir.$file;			
				$thumbfilepath = $thumbdir . $file;
				$testpath=$thumbfilepath;
				$ext=pathinfo($file, PATHINFO_EXTENSION);
				if($ext=="pdf"){
					$testpath=$testpath . ".jpg";
				}elseif($ext=="log" || $ext=="txt" || $ext=="c" || $ext=="conf"|| $ext=="h"|| $ext=="cmd"|| $ext=="bat"|| $ext=="py"|| $ext=="sh"){
					$testpath=$testpath . ".png";
				}
				if(( !file_exists($thumbfilepath) && ! file_exists( $thumbfilepath . ".png") && ! file_exists( $thumbfilepath . ".jpg"))  || ( filemtime($testpath) < filemtime($filepath))){ // if thumbnail doesn't exist or file is newer than the thumbnail
					if(filesize($dir.$file)!=0){
						generatethumbs($file,$dir,$type,$thumbdir);
					}else{
						echo $dir . $file.", size of the file is 0";
					}
				}	
	}
}
//function sortfiles($dir,$files){
       // MAKE YOUR OWN ARRAY
//	return $files;
//}
function loopfiles($files,$dir,$type,$iconpath,$view){
	if($type=="list"){
		$x=0;
		if(isset($files['folders'])){
			foreach($files['folders'] as $file){
				$test=true;
				if($test){
					filelist($file,$dir,$x++,$iconpath,$view);				
				}	
			}	
		}
		//$files=sortfiles($dir,$files);
		if(isset($files['files'])){
			foreach($files['files'] as $file){
				thumbnail($dir,$file,"list");
				filelist($file,$dir,$x++,$iconpath,$view);	
			}	
		}
	if(empty($files['folders'])&&empty($files['files'])){
		echo "No files or folders found in this folder";
	}
	}elseif($type=="grid"){
		$x=0;
		echo '<div class="allcontainer">';
		if(isset($files['folders'])){
			foreach($files['folders'] as $file){
				$test=true;
				if($test){
					FileGrid($file,$dir,$iconpath,$view,$x++);				
				}	
			}	
		}
		if(isset($files['files'])){
			foreach($files['files'] as $file){
				thumbnail($dir,$file,"grid");
				FileGrid($file,$dir,$iconpath,$view,$x++);		
			}
		}
		echo '</div>';
		if(empty($files['folders'])&&empty($files['files'])){
			echo "No files or folders found in this folder";
		}
	}elseif($type=="jpg"){
		if(isset($files['files'])){
			if(isset($_GET['pic'])){
				$piccount=count($GLOBALS['pics']);
				$offset=filter_input(INPUT_GET, 'pic', FILTER_VALIDATE_INT);
				if($piccount<=$offset || $offset < 0){
					$offset=0;
				}
			}		
			if(!isset($offset)){
				$offset=0;
			}
			if(!is_dir($dir .$GLOBALS['pics'][0+$offset])){
				echo '<a href="?dir='.$dir.'&dl='.$GLOBALS['pics'][0+$offset] .'">';
			}
			echo '<div class="fullcontainer">';
			if(is_dir($GLOBALS['pics'][0+$offset])){
				echo "<div class=jpggridcontainer>";
			}
			if($GLOBALS['pics']!=null){
				thumbnail($dir,$GLOBALS['pics'][0+$offset],"jpg");
				showthumb($dir,$GLOBALS['pics'][0+$offset],$view,$iconpath,null,"full","jpg",null);	
			}else{
				echo '<div style="width:100%;height:100%;">';
				echo '<div class="no-picture" style="display:inline-block";width:100%;>';
				if($GLOBALS['alljpg']){
					echo "No files/pictures found in this folder";
				}else{
					echo "No pictures found in this folder";
				}
				echo '</div>';
				echo '</div>';
			}
			if(is_dir($GLOBALS['pics'][0+$offset])){		
				echo "</div>";
			}
			echo '</div>';
			if(!is_dir($dir .$GLOBALS['pics'][0+$offset])){
				echo '</a>';
			}
			echo '</div>';

			$yy=0;


			if($offset!=0){
				echo '<div class="bottom">';
		     		echo '<div class="allign">';
				echo '<a href="?pic=0&amp;alljpg='.$GLOBALS['alljpg'].'&amp;view=jpg&amp;dir='.$dir.'">';
				echo '<div class="first">';
				echo '<div class="buttonalign">';
				echo '&lt;&lt;';
				echo '</div>';
				echo '</div>';
				echo '</a>';
		     		if($offset>4){
					echo '<a href="?pic='.($offset-5).'&amp;alljpg='.$GLOBALS['alljpg'].'&amp;view=jpg&amp;dir='.$dir.'">';
					echo '<div class="previous5">';
					echo '<div class="buttonalign">';
					echo '&lt;5';
					echo '</div>';
					echo '</div>';
					echo '</a>';
				}else{
					echo '<div class="previousg5">';
					echo '<div class="buttonalign">';
			     		echo '&lt;5';
			     		echo '</div>';
			     		echo '</div>';
		    		 }
		     		echo '<a href="?pic='.($offset-1).'&amp;alljpg='.$GLOBALS['alljpg'].'&amp;view=jpg&amp;dir='.$dir.'">';
		     		echo '<div class="previous">';
				echo '<div class="buttonalign">';
				echo '&lt;';
				echo '</div>';
				echo '</div>';
				echo '</a>';
		     }else{
				echo '<div class="bottom">';
				echo '<div class="allign">';
				echo '<div class="firstg">';
				echo '<div class="buttonalign">';
				echo '&lt;&lt;';
				echo '</div>';
				echo '</div>';
				echo '<div class="previousg5">';
				echo '<div class="buttonalign">';
				echo '&lt;5';
				echo '</div>';
				echo '</div>';
				echo '<div class="previousg">';
				echo '<div class="buttonalign">';
				echo '&lt;';
				echo '</div>';
				echo '</div>';
			}
			if(isset($GLOBALS['pics'])){
				$count=count($GLOBALS['pics']);
				foreach($GLOBALS['pics'] as $file){
					if($yy==$offset){
						thumbnail($dir,$file,"grid");
						if(is_dir($dir . $file)){
							echo '<a href="?pic=0&amp;view=jpg&amp;alljpg='.$GLOBALS['alljpg'].'&dir='.$dir . $file.'">';
						}else{
							echo '<a href="?dir='.$dir ."&dl=". $file .'">';
						}
						FileSelect($file,$dir,$iconpath,$yy,true,$offset);
						echo '</a>';
					}else{
						if((abs($yy-$offset))<4 || ((($yy)<7) && $offset==0) || ((($yy)<7) && $offset==1) || ((($yy)<7) && $offset==2)){
							thumbnail($dir,$file,"grid");
							echo '<a href="?pic='. $yy .'&amp;view=jpg&amp;alljpg='.$GLOBALS['alljpg'].'&amp;dir='.$dir.'">';
							FileSelect($file,$dir,$iconpath,$yy,false,$offset);
							echo '</a>';
						}elseif($offset==($count-1) && ($yy-$offset)>-7){
							thumbnail($dir,$file,"grid");
							echo '<a href="?pic='. $yy .'&amp;view=jpg&amp;alljpg='.$GLOBALS['alljpg'].'&amp;dir='.$dir.'">';
							FileSelect($file,$dir,$iconpath,$yy,false,$offset);
							echo '</a>';
						}elseif($offset==($count-2) && ($yy-$offset)>-6){
							thumbnail($dir,$file,"grid");
							echo '<a href="?pic='. $yy .'&amp;view=jpg&amp;alljpg='.$GLOBALS['alljpg'].'&amp;dir='.$dir.'">';
							FileSelect($file,$dir,$iconpath,$yy,false,$offset);
							echo '</a>';
						}elseif($offset==($count-3) && ($yy-$offset)>-5){
							thumbnail($dir,$file,"grid");
							echo '<a href="?pic='. $yy .'&amp;view=jpg&amp;alljpg='.$GLOBALS['alljpg'].'&amp;dir='.$dir.'">';
							FileSelect($file,$dir,$iconpath,$yy,false,$offset);	
							echo '</a>';
						}
					}
				$yy++;
				}
				if($offset!=($count-1)){
					echo '<a href="?pic='.($offset+1).'&amp;alljpg='.$GLOBALS['alljpg'].'&amp;view=jpg&amp;dir='.$dir.'">';
					echo '<div class="next">';
					echo '<div class="buttonalign">';
					echo '&gt;';
					echo '</div>';
					echo '</div>';
					echo '</a>';
					if(($offset+5)<$count){
						echo '<a href="?pic='.($offset+5).'&amp;alljpg='.$GLOBALS['alljpg'].'&amp;view=jpg&amp;dir='.$dir.'">';
						echo '<div class="next5">';
						echo '<div class="buttonalign">';
						echo '5&gt;';
						echo '</div>';
						echo '</div>';
						echo '</a>';
					}else{
						echo '<div class="nextg5">';
						echo '<div class="buttonalign">';
						echo '5&gt;';
						echo '</div>';
						echo '</div>';
					}
					echo '<a href="?pic='. ($count-1) .'&amp;alljpg='.$GLOBALS['alljpg'].'&amp;view=jpg&amp;dir='.$dir.'">';
					echo '<div class="last">';
					echo '<div class="buttonalign">';
					echo '&gt;&gt;';
					echo '</div>';			
					echo '</div>';
					echo '</a>';
					echo '</div>';
					echo '</div>';
				}else{
					echo '<div class="nextg">';
					echo '<div class="buttonalign">';
					echo '&gt;';
					echo '</div>';
					echo '</div>';
					echo '<div class="nextg5">';
					echo '<div class="buttonalign">';
					echo '5&gt;';
					echo '</div>';
					echo '</div>';
					echo '<div class="lastg">';
					echo '<div class="buttonalign">';
					echo '&gt;&gt;';
					echo '</div>';			
					echo '</div>';
					echo '</div>';
					echo '</div>';	
				}
			}else{
				echo '<div class="nextg">';
				echo '<div class="buttonalign">';
				echo '&gt;';
				echo '</div>';
				echo '</div>';
				echo '<div class="nextg5">';
				echo '<div class="buttonalign">';
				echo '5&gt;';
				echo '</div>';
				echo '</div>';
				echo '<div class="lastg">';
				echo '<div class="buttonalign">';
				echo '&gt;&gt;';
				echo '</div>';			
				echo '</div>';
				echo '</div>';
				echo '</div>';	
			}
		}
		if(isset($GLOBALS['pics'])){
		keypress($offset,$count,$dir);}
	}
}
function keypress($offset,$count,$dir){ // uses javascript to grap the left, right keypressess
	$previous=$offset-1;
	$next=$offset+1;
	if($previous<0){
		$previous=0;
	}
	if($next>=($count-1)){
		$next=($count-1);
	}
	$alljpg=$GLOBALS['alljpg'];
	echo "
<script type=\"text/javascript\">
document.addEventListener(\"keydown\", function (e) {
  if([37,38,39,40].indexOf(e.keyCode) > -1){
    e.preventDefault();
  }
}, false);";
if($offset!="0"){
	echo "function leftArrowPressed() {
	location.href = \"?pic=$previous&alljpg=$alljpg&view=jpg&dir=$dir\";
	}";
	echo "function downArrowPressed() {
	location.href = \"?pic=0&alljpg=$alljpg&view=jpg&dir=$dir\";
	}";
}
if($offset!=$count-1){
	$last=$count-1;
	echo "function rightArrowPressed() {
   	location.href = \"?pic=$next&alljpg=$alljpg&view=jpg&dir=$dir\";
	}";
	echo "function upArrowPressed() {
   	location.href = \"?pic=$last&alljpg=$alljpg&view=jpg&dir=$dir\";
	}";
}
echo "
document.onkeydown = function(evt) {
    evt = evt || window.event;
    switch (evt.keyCode) {
        case 37:
            leftArrowPressed();
            break;
        case 38:
            upArrowPressed();
            break;    
        case 39:
            rightArrowPressed();
            break;
        case 40:
            downArrowPressed();
            break;
    }
};
</script>";
}
function filelist($file,$dir,$x,$iconpath,$view){ // generates the list view
	$odd=$x;
	$filepath=str_replace("/./","/",$dir.$file );
	$filepath = implode('/', array_map('rawurlencode', explode('/', $filepath)));
	$Lfilepath=$filepath;
	$thumbfilepath=str_replace("/./","/",$GLOBALS["thumbPath"]. $dir . "list" . "/" . $file);
	$thumbfilepath= implode('/', array_map('rawurlencode', explode('/', $thumbfilepath)));
	$filetype="";
	$supported=in_array("." .strtolower(pathinfo($file, PATHINFO_EXTENSION)),$GLOBALS["supportedthumbs"]);		
	if(is_dir($dir . $file)){
		$filetype="dir";
	}else{
		foreach($GLOBALS["supported"] as $filetypetest){
			$length = strlen($filetypetest);
			if (strtolower(substr($file, -$length)) === $filetypetest ){
				$filetype = strtolower(substr($file,-$length+1));
				break;
			}
		}
	}
	if( $odd % 2 == 0){
	     echo '<div class="fileinfo">';
	}else{
	     echo '<div class="fileinfo2">';
	}
	echo '<div class="spacer2">';	
	echo '&nbsp;';
	echo '</div>';
	echo '<div class="downloadlist">';
	if($filetype!="dir" && $filetype!="index.php"){
		echo '<a href="?dir='.$dir.'&dl='.$file.'"><img class="downloadicon" src="' . $iconpath . '/download.png" alt="dl"/>';
		echo '</a>';
	}else{
		echo 	'<div class="cube">';	
		echo 	'&nbsp;';
		echo '</div>';
	}
	echo '</div>';
	echo '<div class="spacer2">';	
	echo '&nbsp;';
	echo '</div>';
	if($filetype=="dir"){			
		if($view=="jpg"){
			echo '<a class="nameLink"  href="?pic='. $odd .'&amp;view=jpg&amp;alljpg='.$GLOBALS['alljpg'].'&amp;dir='.$filepath.'">';
		}else{
			echo '<a class="nameLink"  href="?view=list&amp;dir=',$filepath,'">';
		}
	}elseif($filetype=="index.php"){
		echo '<a class="nameLink"  href="',dirname($filepath),'/?reset=1">';
	}else{
		if($supported){
			echo '<a class="nameLink" href="?pic='. $odd .'&amp;view=jpg&amp;alljpg='.$GLOBALS['alljpg'].'&amp;dir='.$dir.'">';
		}else{
			echo '<a class="nameLink"  href="?dir='.$dir.'&dl='.$file.'">';	
		}		
	}
	echo '<div class="fileicon">';
	showthumb($dir,$file,$view,$iconpath,null,"icon","list",$odd);
	echo '</div>';
	echo '<div class="spacer2">';	
	echo '&nbsp;';
	echo '</div>';
	echo '<div class="name">';	
	if($filetype=="index.php"){
		trim(dirname($filepath),"./");
	}else{
		echo $file;
	}
	echo '</div>';
	echo '</a>';
	echo '<div class="spacer">';	
	echo '&nbsp;';
	echo '</div>';
	echo '<div class="type">';	
	if($filetype!="dir" &&  $filetype != "index.php"){
		echo pathinfo($file, PATHINFO_EXTENSION);
	}else{
		echo "&nbsp;";
	}
	echo '</div>';
	echo '<div class="spacer">';	
	echo '&nbsp;';
	echo '</div>';
	echo '<div class="modified">';	
	if($filetype!="index.php"){
		echo  date("Y.m.d H:i",filemtime($dir.$file));		
	}else{
		echo date("Y.m.d H:i",filemtime(dirname($dir . $file)));
	}
	echo '</div>';
	echo '<div class="spacer">';	
	echo '&nbsp;';
	echo '</div>';
	echo '<div class="filesize">';	
	if($filetype!="dir" && $filetype!="index.php"){
		echo human_filesize(filesize($dir.$file));
	}else{
		echo "Folder";
	}
	echo '</div>';
	echo '<div class="spacer">';	
	echo '&nbsp;';
	echo '</div>';
	echo '</div>';	
}
function showthumb($dir,$file,$view,$iconpath,$alljpg,$class,$type,$id){ // creates single img (in some cases inside <a>)
	$filetype="";
	$filepath=str_replace("/./","/",$dir.$file );
	$Lfilepath=$filepath;
	$filepath = implode('/', array_map('rawurlencode', explode('/', $filepath)));
	$thumbfilepath=str_replace("/./","/",$GLOBALS["thumbPath"]. $dir . "." . $type . "/" . $file);
	$Linkthumbfilepath=$thumbfilepath;
	$thumbfilepath= implode('/', array_map('rawurlencode', explode('/', $thumbfilepath)));
	if(is_dir($dir . $file)){
		$filetype="dir";
	}else{
		foreach($GLOBALS["supported"] as $filetypetest){
			$length = strlen($filetypetest);
			if (strtolower(substr($file, -$length)) === $filetypetest ){
				$filetype = strtolower(substr($file,-$length+1));
				break;
			}
		}
	}	
	switch ($filetype):	
		case "jpeg":
		case "jpg":
		case "png":
		case "gif":
			if(file_exists($Linkthumbfilepath)){
				echo '<img class="'.$class.'" src="'. $thumbfilepath;
				echo '" alt="'.$dir.$file. ' thumb"/>';	
			}else{
				echo "thumnails not found";echo $thumbfilepath;
			}
		break;
		case "c":
		case "bat":
		case "py":
		case "sh":
		case "conf":	
		case "h":
		case "cmd":
		case "bat":
		case "txt":
		case "log":
			if(file_exists($Linkthumbfilepath . ".png")){
				echo '<img class="'.$class.'" src="',$thumbfilepath . ".png";
				echo '" alt="',$dir.$file, ' thumb" />';
			}else{
				echo "error";echo $thumbfilepath . ".png";
			}
		break;
		case "dir":
			if($class=="full"){
				$files['files']=scandir($dir . $file);	
				$files = removeExtra($files,$dir.$file."/",$GLOBALS['allowedDepth'],$GLOBALS['privateFiles'],$GLOBALS['privateFolders']);
				infobar($iconpath);
				loopfiles($files,$dir . $file . "/","list",$iconpath,$view);
				infobar($iconpath);
			}else{
				echo '<img class="'.$class.'" alt="Directory " src="' . $iconpath . '/folder.png" />';	
			}			
		break;
		case "pdf":
			if(file_exists($Linkthumbfilepath . ".jpg")){
				echo '<img class="'.$class.'" src="', $thumbfilepath . ".jpg";
				echo '" alt="',$dir.$file, ' thumb"/>';
			}else{
				echo "!";
			}
		break;	
		case "doc":
		case "docx":
			if($class=="full"){
				echo '<div class="img-with-text">';
			}
			echo '<img alt="doc" class="'.$class.'" src="' . $iconpath . '/page_word.png"  />';
			if($class=="full"){
				echo '<p class="img-text">'.$file.'</p>';
				echo "</div>";
			}
		break;			
		case "xls":
		case "xlsx":
			if($class=="full"){
				echo '<div class="img-with-text">';
			}
			echo '<img alt="Excel file" class="'.$class.'" src="' . $iconpath . '/page_excel.png"  />';
			if($class=="full"){
				echo '<p class="img-text">'.$file.'</p>';
				echo "</div>";
			}
		break;	
			case "iso":
			case "bin":
			case "img":
			if($class=="full"){
				echo '<div class="img-with-text">';
			}
			echo '<img alt="disk image file" class="'.$class.'" src="' . $iconpath . '/page_white_dvd.png"  />';
			if($class=="full"){
				echo '<p class="img-text">'.$file.'</p>';
				echo "</div>";
			}
		break;	
		case "ppt":
		case "pptx":
			if($class=="full"){
				echo '<div class="img-with-text">';
			}
			echo '<img alt="Powerpoint file" class="'.$class.'" src="' . $iconpath . '/page_white_powerpoint.png"  />';
			if($class=="full"){
				echo '<p class="img-text">'.$file.'</p>';
				echo "</div>";
			}
			break;		
		case "zip":
		case "rar":
		case "7z":
		case "tar":
		case "gz":
			if($class=="full"){echo '<div class="img-with-text">';}
			echo '<img alt="Compressed file" class="'.$class.'" src="' . $iconpath . '/compress.png"  />';
			if($class=="full"){
				echo '<p class="img-text">'.$file.'</p>';
				echo "</div>";
			}
		break;	
		case "mp3":
		case "flac":
		case "wav":
		case "m4a":
		case "wma":
		case "mid":
		case "m3u":
		case "pls":
			if($class=="full"){echo '<div class="img-with-text">';}
			echo '<img alt="audio file" class="'.$class.'" src="' . $iconpath . '/music.png"  />';
			if($class=="full"){
				echo '<p class="img-text">'.$file.'</p>';
				echo "</div>";
			}
		break;
		case "ttf":
		case "fon":
		case "otf":
			if($class=="full"){echo '<div class="img-with-text">';}
			echo '<img alt="font file" class="'.$class.'" src="' . $iconpath . '/font.png"  />';
			if($class=="full"){
				echo '<p class="img-text">'.$file.'</p>';
				echo "</div>";
			}
		break;
		case "avi":
		case "mp4":
		case "mkv":
		case "mpeg":
		case "flv":
		case "mov":
		case "mpq":
			if($class=="full"){echo '<div class="img-with-text">';}
			echo '<img alt="video file" class="'.$class.'" src="' . $iconpath . '/film.png"  />';
			if($class=="full"){
				echo '<p class="img-text">'.$file.'</p>';
				echo "</div>";
			}
		break;	
		case "dmg":
		case "rpm":
		case "deb":
		case "apk":
		case "msi":
			if($class=="full"){echo '<div class="img-with-text">';}
			echo '<img alt="Installer file" class="'.$class.'" src="' . $iconpath . '/package.png" />';
			if($class=="full"){
				echo '<p class="img-text">'.$file.'</p>';
				echo "</div>";
			}
		break;
		case "exe":
			if($class=="full"){echo '<div class="img-with-text">';}
			echo '<img alt="Executable file" class="'.$class.'" src="' . $iconpath . '/application.png"  />';
			if($class=="full"){
				echo '<p class="img-text">'.$file.'</p>';
				echo "</div>";
			}
		break;				
		default:
			if($class=="full"){
				echo '<div class="img-with-text">';
			}
			echo '<img alt="!" class="'.$class.'" src="/icons/unknown.png"  />';
			if($class=="full"){
				echo '<p class="img-text">'.$file.'</p>';
				echo "</div>";
			}		
			break;
		endswitch;
}
function FileGrid($file,$dir,$iconpath,$view,$id){ // generates single file in grid view
	$filetype="";
	$filepath=str_replace("/./","/",$dir.$file );
	$Lfilepath=$filepath;
	$filepath = implode('/', array_map('rawurlencode', explode('/', $filepath)));
	if(is_dir($dir . $file)){
		$filetype="dir";
	}else{
		foreach($GLOBALS["supported"] as $filetypetest){
			$length = strlen($filetypetest);
			if (strtolower(substr($file, -$length)) === $filetypetest ){
				$filetype = strtolower(substr($file,-$length+1));
				break;
			}
		}
	}	
	echo '<div class="container">';
		if(is_dir($dir . $file)){
			echo '<a href="?view=grid&amp;dir='. $dir . $file . '">';
		}elseif(in_array("." .strtolower(pathinfo($file, PATHINFO_EXTENSION)),$GLOBALS["supportedthumbs"])){
			echo '<a href="?pic='. $id .'&amp;view=jpg&amp;alljpg='.$GLOBALS['alljpg'].'&amp;dir='.$dir.'">';
		}else{
			echo '<a href="?dir='.$dir.'&dl='.$file.'">';
		}
		echo '<div class="pictures">';
			echo '<span class="helper"></span>';		
			showthumb($dir,$file,$view,$iconpath,null,"picture","grid",$id);
			if($filetype=="dir"){
				//	echo '<a href="?view='.$view.'&dir='.$dir . $file.'">';
			echo $file;
				//	echo "</a>";
			}
		echo '</div>';
		echo "</a>";
		echo '<div class="container2">';
			if($filetype=="dir" || $filetype=="index.php"){}else{
				if(in_array("." .strtolower(pathinfo($file, PATHINFO_EXTENSION)),$GLOBALS["supportedthumbs"])){
					echo '<a href="?pic='. $id .'&amp;view=jpg&amp;alljpg='.$GLOBALS['alljpg'].'&amp;dir='.$dir.'">';
				}else{
					echo '<a href="?dir='.$dir.'&dl=' .$file.'">';
				}
				echo '<div class="picturetext">';
					echo "&nbsp;";
				//	echo '<a href="',$filepath,'">'
					echo $file; 
				//	echo '</a>'," ";
				echo '</div>';
				echo '</a>';
				echo '<div class="download">';
					echo '<a href="?dir='.$dir . '&dl='.$file.'">';
					echo '<img src="' . $iconpath . '/download.png" alt="dl" />';
					echo '</a>';
				echo '</div>';
			}

		echo '</div>';
	echo '</div>';
	return 1;
}

function FileSelect($file,$dir,$iconpath,$index,$selected,$offset){ //generates single thumbnail container for jpg mode
	$filetype="";
	$filepath=str_replace("/./","/",$dir.$file );
	$filepath = implode('/', array_map('rawurlencode', explode('/', $filepath)));

	if(is_dir($dir . $file)){
		$filetype="dir";
	}else{
		foreach($GLOBALS["supported"] as $filetypetest){
			$length = strlen($filetypetest);
			if (strtolower(substr($file, -$length)) === $filetypetest ){
				$filetype = strtolower(substr($file,-$length+1));
				break;
			}
		}
	}	
	$supported=in_array("." .$filetype,$GLOBALS["supportedthumbs"]);

	if($selected){
		echo '<div class="currentselectcontainer">';	
	}else{
		echo '<div class="selectcontainer">';
	}
	if($filetype=="dir" || !$supported ){
		echo '<div class="selectpictures2">';
	}else{
		echo '<div class="selectpictures">';
	}
		
			if($filetype=="dir" || !$supported ){	
			}else{
				echo '<span class="helper"></span>';
			}
				showthumb($dir,$file,'jpg',$iconpath,null,"selectpicture","grid",null);
				if($filetype=="dir" || !$supported ){
					echo "<br>";
					echo $file;
				}
				echo '</div>';
		echo '</div>';
	
	return 1;
}

function generatethumbs($file,$dir,$type,$thumbdir){ /// Generates the thumbnails 
	switch($type):
		case "grid":
			$thumbWidth = $GLOBALS["thumbWidthGrid"];
			$limit=350;	
			$fontsize=10;	
			$y=14;		//Start place for first line
			$space=14;  	//Space between lines
		break;
		case "list":
			$thumbWidth = $GLOBALS["thumbWidthList"];
			$limit=20;
			$fontsize=4;
			$y=4;		//Start place for first line
			$space=5;  	//Space between lines
		break;
		case "jpg":
			$thumbWidth = $GLOBALS["thumbWidthJpg"];
			$limit=1940;
			$fontsize=20;
			$y=28;		//Start place for first line
			$space=30;  	//Space between lines
		break;
		default:
			echo "FAILURE";
			exit;
		break;
	endswitch;
	if(!file_exists("/usr/share/httpd/icons/fv/") && !file_exists("/usr/share/apache2/icons/fv/") && !file_exists("/var/www/icons/")&& !file_exists("./.icons/")){
		if($GLOBALS['warnings']){
			echo "Warning: icon folder doesn't exist, some icons will be shown as text<br>";
		}
	}
	
	$i = 0;
	$status=true;		
	if (!file_exists($thumbdir)){					// Create the thumbnail folder if it doesn't exist
		$status=mkdir($thumbdir, 0755, true);
		chmod(str_replace("/./","/",$GLOBALS["thumbPath"]),0755);
		chmod(str_replace("/./","/",$GLOBALS["thumbPath"].$dir),0755);
		chmod($thumbdir, 0755);
	}
	if(!$status && $GLOBALS['warnings'] ){							// Display error if creating the folder failed
		echo '<br>error creating folder ="',$thumbdir,'" or "'.$thumbdir . $type.'", check permissions<br>';
		echo 'Create folder called ".thumbs" in the same folder as this script and give all users read, write and access rights<br>';
		echo 'Example<br> ';
		echo 'mkdir ./.thumbs<br>';
		echo 'chmod a+rwx ./.thumbs/';
	}
	elseif(!is_writable($thumbdir) && $GLOBALS['warnings']){				// Display error if the thumbnail directory is not writable
		echo 'error while trying to write in ="',$thumbdir,'", check permissions<br>';
		echo 'Folder called ".thumbs" in the same folder as this script must have read, write and acess rights for all<br>';
		echo 'Example<br> ';
		echo 'chmod a+rwx ./.thumbs/';
	}else{								// if nothing failed goes here
		if (!file_exists($thumbdir . "index.html")){
			touch($thumbdir . "index.html");
			chmod($thumbdir . "index.html", 0644);
		} //creates empty index file for thumbnail folder
		$filepath= $dir.$file;		
		$thumbfilepath=str_replace("/./","/",$thumbdir . $file);	
			foreach($GLOBALS["supportedthumbs"] as $filetype){	//loops through supported files
				$length = strlen($filetype);			
				if (substr($file, -$length) === $filetype || strtolower(substr($file, -$length)) === $filetype ){ // if file type matches with supported file type
					switch (strtolower(substr($file, -$length+1))): // Cut file name to just file type and make it lower case.
						case "pdf":
							if(extension_loaded('imagick')){
								$output=shell_exec ('pdfinfo ' . $filepath . ' | grep -c "Quartz PDFContext"');
								$gsversion=shell_exec('/usr/bin/gs --version 2>&1');
								if($output==0 || $gsversion>8.70){
									$imagick = new Imagick(); 			// Create the variable
									$imagick->setResolution(80, 80);		// Set dpi to 50
									$imagick->readImage($filepath . '[0]');		// Read first page of the pdf
									$imagick = $imagick->mergeImageLayers(Imagick::LAYERMETHOD_FLATTEN);  		// Combine layers
									$imagick->resizeImage($thumbWidth,0,0,1);
									$imagick->writeImages($thumbfilepath . ".jpg", false); 	// Write the image
									chmod($thumbfilepath . ".jpg", 0644);
								}elseif($GLOBALS['pdfQuartzwarnings']==true){
									echo $filepath . ", Mac OS X Quartz PDFContext genrated pdf have problem with GPL Ghostscript 8.70 thumbnail disabled<br>";
								}
							}elseif($GLOBALS['warnings']){
								echo "Warning: Can't find php extension Imagick. PDF thumbnail generation is disabled.<br>";
							}
							break;
						case "jpeg":
						case "jpg":
							if(function_exists('imagecreatefromjpeg')){
								$img = imagecreatefromjpeg($filepath);		// Read the image
								$width = imagesx ( $img );			// Get the width
								if($width<=$thumbWidth){
									copy($filepath,$thumbfilepath);	
								}else{
									$height = imagesy ( $img );			// Get the height
									$newWidth = $thumbWidth;
									$newHeight = floor ( $thumbWidth * ( $height / $width ) ); // Calculate the new height	
									$tmpImg = imagecreatetruecolor( $newWidth, $newHeight );   // initialize the variable
									imagecopyresized( $tmpImg,$img,0,0,0,0,$newWidth,$newHeight,$width,$height); // save the thumbnail to variable 
									imagejpeg( $tmpImg, $thumbfilepath);		// Write the file
								}
								chmod($thumbfilepath, 0644);			
							}else{
								echo "Function imagecreatefromjpeg not loaded<br>";
							}
							break;
						case "png":
							if(function_exists('imagecreatefrompng')){	
								$img = imagecreatefrompng($filepath);
								$width = imagesx ( $img );
								if($width<=$thumbWidth){
									copy($filepath,$thumbfilepath);
								}else{
									$height = imagesy ( $img );
									$newWidth = $thumbWidth;
									$newHeight = floor ( $thumbWidth * ( $height / $width ) ); // Calculate the new height	
									$tmpImg = imagecreatetruecolor( $newWidth, $newHeight );
									imagecopyresized( $tmpImg,$img,0,0,0,0,$newWidth,$newHeight,$width,$height);
									imagepng( $tmpImg, $thumbfilepath);
								}
								chmod($thumbfilepath, 0644);
							}else{
								echo "Function imagecreatefrompng not loaded<br>";
							}
							break;
						case "gif":
							if(function_exists('imagecreatefromgif')){
								if(filesize($filepath)<$GLOBALS['GifSizeLimit']){
									copy($filepath,$thumbfilepath);
								}else{
									$img = imagecreatefromgif($filepath);
									$width = imagesx ( $img );
									$height = imagesy ( $img );
									$newWidth = $thumbWidth;
									$newHeight = floor ( $thumbWidth * ( $height / $width ) ); // Calculate the new height	
									$tmpImg = imagecreatetruecolor( $newWidth, $newHeight );
									imagecopyresized( $tmpImg,$img,0,0,0,0,$newWidth,$newHeight,$width,$height);
									imagegif( $tmpImg, $thumbfilepath);
								}
								chmod($thumbfilepath, 0644);
							}else{
								echo "Function imagecreatefromgif not loaded<br>";
							}
							break;
						case "log":
						case "txt":
						case "c":
						case "bat":
						case "py":
						case "sh":
						case "conf":	
						case "h":
						case "cmd":
						case "bat":
						case "txt":
						case "log":
							if(function_exists('imagecreatetruecolor') && function_exists('imagettftext') ){
								if(file_exists("/usr/share/httpd/icons/fvh/DroidSansMono.ttf")){
									$font="/usr/share/httpd/icons/fv/DroidSansMono.ttf";  // Font for generating thumbnails of txt files
								}elseif(file_exists("/usr/share/apache2/icons/fv/DroidSansMono.ttf")){
									$font="/usr/share/apache2/icons/fv/DroidSansMono.ttf";
								}elseif(file_exists("/var/www/icons/fv/DroidSansMono.ttf")){
									$font="/var/www/icons/fv/DroidSansMono.ttf";
								}elseif(file_exists("./.icons/DroidSansMono.ttf")){
									$font="./.icons/DroidSansMono.ttf";
								}else{
									if($GLOBALS['warnings']){
										echo "Warning: Couldn't find font file, won't be generating txt and log thumbs.<br>";
									}
									$font=false;
								}
								if($font){
									$newWidth = ($thumbWidth);
									$newHeight = ($thumbWidth);
									$tmpImg = imagecreatetruecolor( $newWidth, $newHeight );			// initialize the variable
									$text_color = imagecolorallocate($tmpImg, 0, 0, 0);		// Set the text colour
									$background_color = imagecolorallocate($tmpImg, 255, 255, 255);	// Set the background colour
									imagefill ($tmpImg,0,0,$background_color);			// Paint the background
									$handle = fopen($filepath, "r");				// Open the source txt
									if($handle){							// if while was opened 
										while (($line = fgets($handle)) !== false) {		// loop the lines of the txt
											$line = str_replace("\t",'        ',$line);
											imagettftext($tmpImg, $fontsize,0,0,$y,$text_color,$font,substr($line,0,-1));	// write the txt to the variable line by line
											//imagestring($tmpImg, 4, 0, $y,substr($line,0,-1), $text_color);	// not so pretty way to do it
											$y+=$space;									// go one line down in the picture
											if($y>$limit){
												break;							// break after x/y lines
											}
										}
									 	fclose($handle);					// Close the source file
	 									imagepng( $tmpImg, $thumbfilepath.".png");		// Save png file
										 chmod($thumbfilepath.".png", 0644);
									}elseif($GLOBALS['warnings']){
										echo "error reading txt file<br>";
									}
								}
							}else{
								echo "Function imagecreatetruecolor or imagettftext not loaded.<br>";
							}
							break;
						default:
							break;
					endswitch;
					break;
				}		
		}			
	}
}
if(!isset($_GET["dl"])){
	echo  "</body></html>";
}
?> 
